/* Driver for Realtek card reader
 *
 * Copyright(c) 2012 Realtek Semiconductor Corp. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *   edwin.rong(edwin_rong@realsil.com.cn)
 *   No. 450, Shenhu Road, Suzhou Industry Park, Suzhou, China
 *
 *   Tony.Nie(tony_nie@realsil.com.cn)
 *   No. 450, Shenhu Road, Suzhou Industry Park, Suzhou, China
 */

/* NOTE: if new card needs to be suppored, attached its definition as the last
 * one, DO NOT break the original order */

#include "cardmanager.h"
#include "cards/sd.h"
#include "cards/ms.h"
#include "cards/xd.h"

struct card_config_parameter card_sets[REALTEK_MAX_CARD_ID] = {
	{
		.name = "sd",
		.id = SD_ID,
		.extra_size = sizeof(struct sd_info),
		.lun = LUN0,
		.callback = {
			.reset = sd_card_reset,
			.disable = sd_card_disable,
			.rw = sd_card_rw,
			.cleanup = sd_card_cleanup,
			.release = sd_card_release,
			.update_report_status = sd_card_update_status,
		},
	}, {
		.name = "ms",
		.id = MS_ID,
		.extra_size = sizeof(struct ms_info),
		.lun = LUN1,
		.callback = {
			.reset = ms_card_reset,
			.disable = ms_card_disable,
			.rw = ms_card_rw,
			.cleanup = ms_card_cleanup,
			.release = ms_card_release,
		},
	}, {
		.name = "xd",
		.id = XD_ID,
		.extra_size = sizeof(struct xd_info),
		.lun = LUN2,
		.callback = {
			.reset = xd_comm_reset,
			.disable = xd_comm_disable,
			.rw = xd_comm_rw,
			.cleanup = xd_comm_cleanup,
			.release = xd_comm_release,
		},
	},

};
