/* Driver for Realtek card reader
 *
 * Copyright(c) 2013 Realtek Semiconductor Corp. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *
 *   Tony.Nie(tony_nie@realsil.com.cn)
 *   No. 450, Shenhu Road, Suzhou Industry Park, Suzhou, China
 */

#include <linux/kernel.h>
#include <linux/pci.h>
#include <linux/device.h>
#include <linux/module.h>
#include "cr_driver.h"
#include "cr_sysfs.h"

/* show sw paramter */
cr_show_sw_param32(mspro_formatter_enable);
cr_show_sw_param32(fpga_sd_sdr104_clk);
cr_show_sw_param32(fpga_sd_ddr50_clk);
cr_show_sw_param32(fpga_sd_sdr50_clk);
cr_show_sw_param32(fpga_sd_hs_clk);
cr_show_sw_param32(fpga_mmc_52m_clk);
cr_show_sw_param32(fpga_mmc_sdr200_clk);
cr_show_sw_param32(fpga_ms_hg_clk);
cr_show_sw_param32(fpga_ms_4bit_clk);
cr_show_sw_param32(fpga_ms_1bit_clk);
cr_show_sw_param32(asic_sd_sdr104_clk);
cr_show_sw_param32(asic_sd_ddr50_clk);
cr_show_sw_param32(asic_sd_sdr50_clk);
cr_show_sw_param32(asic_sd_hs_clk);
cr_show_sw_param32(asic_mmc_52m_clk);
cr_show_sw_param32(asic_ms_hg_clk);
cr_show_sw_param32(asic_ms_4bit_clk);
cr_show_sw_param32(asic_ms_1bit_clk);
cr_show_sw_param32(asic_mmc_sdr200_clk);
cr_show_sw_param32(cd_debounce_time);
cr_show_sw_param8(ssc_depth_sd_sdr104);
cr_show_sw_param8(ssc_depth_sd_ddr50);
cr_show_sw_param8(ssc_depth_sd_sdr50);
cr_show_sw_param8(ssc_depth_sd_hs);
cr_show_sw_param8(ssc_depth_mmc_52m);
cr_show_sw_param8(ssc_depth_ms_hg);
cr_show_sw_param8(ssc_depth_ms_4bit);
cr_show_sw_param8(ssc_depth_low_speed);
cr_show_sw_param32(mmc_ddr_tx_phase);
cr_show_sw_param32(phase_min_cnt);
cr_show_sw_param32(sd_speed_prior);
cr_show_sw_param32(sd_ctl);
cr_show_sw_param32(sd40_ctl);
cr_show_sw_param32(ss_en);
cr_show_sw_param32(ss_delay);
cr_show_sw_param32(needs_remote_wakeup);
cr_show_sw_param8(ww_enable);
cr_show_sw_param32(ignore_sd);
cr_show_sw_param32(use_hw_setting);
cr_show_sw_param32(ssc_en);
cr_show_sw_param32(auto_delink_en);
cr_show_sw_param32(FT2_fast_mode);
cr_show_sw_param32(pwr_delay);
cr_show_sw_param32(xd_rw_step);
cr_show_sw_param32(D3318_off_delay);
cr_show_sw_param32(delink_delay);
cr_show_sw_param8(rts5129_D3318_off_enable);
cr_show_sw_param8(sd20_pad_drive);
cr_show_sw_param8(sd30_pad_drive);
cr_show_sw_param8(reset_or_rw_fail_set_pad_drive);
cr_show_sw_param8(rcc_fail_flag);
cr_show_sw_param8(rcc_bug_fix_en);
cr_show_sw_param8(debounce_num);
cr_show_sw_param32(polling_time);
cr_show_sw_param32(polling_interval_run);
cr_show_sw_param32(polling_interval_idle);
cr_show_sw_param32(polling_interval_ss);
cr_show_sw_param8(led_toggle_interval);
cr_show_sw_param32(xd_rwn_step);
cr_show_sw_param8(sd_send_status_en);
cr_show_sw_param8(ms_errreg_fix);
cr_show_sw_param8(reset_mmc_first);
cr_show_sw_param8(speed_mmc);
cr_show_sw_param8(blink_led);
cr_show_sw_param8(led_blink_speed);
cr_show_sw_param8(led_always_on);
cr_show_sw_param8(dv18_voltage);
cr_show_sw_param32(adma_mode);
cr_show_sw_param8(lun_mode);
cr_show_sw_param32(otp_valid);
cr_show_sw_param8(dev_aspm_val);
cr_show_sw_param32(power_down_in_ss);
cr_show_sw_param32(baro_pkg);
cr_show_sw_param32(phy_debug_mode);
cr_show_sw_param32(aux_pwr_exist);
cr_show_sw_param8(ms_power_class_en);
cr_show_sw_param32(remote_wakeup_en);
cr_show_sw_param32(ss_idle_period);
cr_show_sw_param32(config_host_aspm);
cr_show_sw_param8(card_drive_sel);
cr_show_sw_param8(sd30_drive_sel_1v8);
cr_show_sw_param8(sd30_drive_sel_3v3);
cr_show_sw_param8(sd30_clk_drive_sel_1v8);
cr_show_sw_param8(sd30_cmd_drive_sel_1v8);
cr_show_sw_param8(sd30_dat_drive_sel_1v8);
cr_show_sw_param8(sd30_clk_drive_sel_3v3);
cr_show_sw_param8(sd30_cmd_drive_sel_3v3);
cr_show_sw_param8(sd30_dat_drive_sel_3v3);
cr_show_sw_param8(sd_400mA_ocp_thd);
cr_show_sw_param8(sd_800mA_ocp_thd);
cr_show_sw_param8(ms_ocp_thd);
cr_show_sw_param8(efuse_ldo_voltage);
cr_show_sw_param32(chk_int_en);
cr_show_sw_param32(led_reverse);
cr_show_sw_param32(led_period);
cr_show_sw_param32(msi_en);
cr_show_sw_param32(sd_timeout);
cr_show_sw_param32(sd40_timeout);
cr_show_sw_param32(xd_timeout);
cr_show_sw_param32(ms_timeout);
cr_show_sw_param32(mspro_timeout);
cr_show_sw_param32(auto_power_down);
cr_show_sw_param32(pmos_pwr_on_interval);
cr_show_sw_param32(sd_voltage_switch_delay);
cr_show_sw_param32(s3_pwr_off_delay);
cr_show_sw_param32(force_clkreq_0);
cr_show_sw_param32(ft2_fast_mode);
cr_show_sw_param32(do_delink_before_power_down);
cr_show_sw_param32(polling_config);
cr_show_sw_param32(delink_stage1_step);
cr_show_sw_param32(delink_stage2_step);
cr_show_sw_param32(delink_stage3_step);
cr_show_sw_param32(auto_delink_in_L1);
cr_show_sw_param32(safe_delink);
cr_show_sw_param32(hp_watch_bios_hotplug);
cr_show_sw_param32(support_ms_8bit);
cr_show_sw_param8(max_payload);
cr_show_sw_param32(sd_current_prior);
cr_show_sw_param32(sd_retry_cnt);
cr_show_sw_param32(sdio_retry_cnt);
cr_show_sw_param32(support_mmc);
cr_show_sw_param32(relink_time);
cr_show_sw_param32(pre_read_en);
cr_show_sw_param32(pre_read_th);
cr_show_sw_param32(sd40_nfcu);
cr_show_sw_param8(sd_io);
cr_show_sw_param8(sd_int);
cr_show_sw_param32(auto_delink_allowed);
cr_show_sw_param32(chip_insert_with_sdio);
cr_show_sw_param32(sdio_aspm);
cr_show_sw_param32(sdio_idle);
cr_show_sw_param32(sdio_counter);
cr_show_sw_param32(sdio_func_exist);
cr_show_sw_param32(sdio_in_charge);
cr_show_sw_param8(sd_sdr104_default_tx_phase);
cr_show_sw_param8(sd_sdr104_default_rx_phase);
cr_show_sw_param8(sd_sdr50_default_tx_phase);
cr_show_sw_param8(sd_sdr50_default_rx_phase);
cr_show_sw_param8(sd_ddr50_default_tx_phase);
cr_show_sw_param8(sd_ddr50_default_rx_phase);
cr_show_sw_param32(ltr_en);
cr_show_sw_param32(ltr_enabled);
cr_show_sw_param32(ltr_active);
cr_show_sw_param32(ltr_active_latency);
cr_show_sw_param32(ltr_idle_latency);
cr_show_sw_param32(ltr_l1off_latency);
cr_show_sw_param32(obff_en);
cr_show_sw_param32(obff_enabled);
cr_show_sw_param32(phy_optimize);
cr_show_sw_param8(ltr_l1off_sspwrgate);
cr_show_sw_param32(l1sub_fe49);
cr_show_sw_param32(phy03_bit5);
cr_show_sw_param32(aux_clk_freq);
cr_show_sw_param32(clk_req_bypass_short);
cr_show_sw_param32(ocp_en);
cr_show_sw_param32(write_clear_interrupt);
cr_show_sw_param8(ltr_l1off_snooze_sspwrgate);
cr_show_sw_param8(reg_0xfe76);
cr_show_sw_param8(sdr_tx_tuning_en);
cr_show_sw_param8(force_host_aspm_val);
cr_show_sw_param16(sd40_ebnum);
cr_show_sw_param8(card_spt_map);
cr_show_sw_param32(sd_capability);
cr_show_sw_param32(dev_aspm_mode);
cr_show_sw_param8(rtd3_en);
cr_show_sw_param32(l1_snooze_delay);
cr_show_sw_param32(n_lss_dir);
cr_show_sw_param32(dev_flags);
cr_show_sw_param32(sd_flags);
cr_show_sw_param32(ms_flags);
cr_show_sw_param32(patch_flags);
cr_show_sw_param32(delay_for_rw_reg);
cr_show_sw_param32(cprm_cmd_timeout);

/* show hw param */
cr_show_hw_param32(interrupt_en);
cr_show_hw_param8(ocp_glitch);
cr_show_hw_param8(av12s);
cr_show_hw_param8(eidle_num);
cr_show_hw_param16(phy0x00_val);
cr_show_hw_param16(phy0x02_val);
cr_show_hw_param16(phy0x01_val);
cr_show_hw_param16(phy0x03_val);
cr_show_hw_param16(phy0x05_val);
cr_show_hw_param16(phy0x08_val);
cr_show_hw_param16(phy0x19_val);
cr_show_hw_param16(phy0x1d_val);
cr_show_hw_param16(phy0x1e_val);
cr_show_hw_param16(phy0x1e_val_l1ss_off);
cr_show_hw_param16(phy0x82_val);
cr_show_hw_param16(phy0x85_val);
cr_show_hw_param16(phy0x87_val);
cr_show_hw_param16(phy0x88_val);
cr_show_hw_param16(phy0x90_val);
cr_show_hw_param16(phy0x92_val);


/* store sw paramter */
cr_store_sw_param32(mspro_formatter_enable);
cr_store_sw_param32(fpga_sd_sdr104_clk);
cr_store_sw_param32(fpga_sd_ddr50_clk);
cr_store_sw_param32(fpga_sd_sdr50_clk);
cr_store_sw_param32(fpga_sd_hs_clk);
cr_store_sw_param32(fpga_mmc_52m_clk);
cr_store_sw_param32(fpga_mmc_sdr200_clk);
cr_store_sw_param32(fpga_ms_hg_clk);
cr_store_sw_param32(fpga_ms_4bit_clk);
cr_store_sw_param32(fpga_ms_1bit_clk);
cr_store_sw_param32(asic_sd_sdr104_clk);
cr_store_sw_param32(asic_sd_ddr50_clk);
cr_store_sw_param32(asic_sd_sdr50_clk);
cr_store_sw_param32(asic_sd_hs_clk);
cr_store_sw_param32(asic_mmc_52m_clk);
cr_store_sw_param32(asic_ms_hg_clk);
cr_store_sw_param32(asic_ms_4bit_clk);
cr_store_sw_param32(asic_ms_1bit_clk);
cr_store_sw_param32(asic_mmc_sdr200_clk);
cr_store_sw_param32(cd_debounce_time);
cr_store_sw_param8(ssc_depth_sd_sdr104);
cr_store_sw_param8(ssc_depth_sd_ddr50);
cr_store_sw_param8(ssc_depth_sd_sdr50);
cr_store_sw_param8(ssc_depth_sd_hs);
cr_store_sw_param8(ssc_depth_mmc_52m);
cr_store_sw_param8(ssc_depth_ms_hg);
cr_store_sw_param8(ssc_depth_ms_4bit);
cr_store_sw_param8(ssc_depth_low_speed);
cr_store_sw_param32(mmc_ddr_tx_phase);
cr_store_sw_param32(phase_min_cnt);
cr_store_sw_param32(sd_speed_prior);
cr_store_sw_param32(sd_ctl);
cr_store_sw_param32(sd40_ctl);
cr_store_sw_param32(ss_en);
cr_store_sw_param32(ss_delay);
cr_store_sw_param32(needs_remote_wakeup);
cr_store_sw_param8(ww_enable);
cr_store_sw_param32(ignore_sd);
cr_store_sw_param32(use_hw_setting);
cr_store_sw_param32(ssc_en);
cr_store_sw_param32(auto_delink_en);
cr_store_sw_param32(FT2_fast_mode);
cr_store_sw_param32(pwr_delay);
cr_store_sw_param32(xd_rw_step);
cr_store_sw_param32(D3318_off_delay);
cr_store_sw_param32(delink_delay);
cr_store_sw_param8(rts5129_D3318_off_enable);
cr_store_sw_param8(sd20_pad_drive);
cr_store_sw_param8(sd30_pad_drive);
cr_store_sw_param8(reset_or_rw_fail_set_pad_drive);
cr_store_sw_param8(rcc_fail_flag);
cr_store_sw_param8(rcc_bug_fix_en);
cr_store_sw_param8(debounce_num);
cr_store_sw_param32(polling_time);
cr_store_sw_param32(polling_interval_run);
cr_store_sw_param32(polling_interval_idle);
cr_store_sw_param32(polling_interval_ss);
cr_store_sw_param8(led_toggle_interval);
cr_store_sw_param32(xd_rwn_step);
cr_store_sw_param8(sd_send_status_en);
cr_store_sw_param8(ms_errreg_fix);
cr_store_sw_param8(reset_mmc_first);
cr_store_sw_param8(speed_mmc);
cr_store_sw_param8(blink_led);
cr_store_sw_param8(led_blink_speed);
cr_store_sw_param8(led_always_on);
cr_store_sw_param8(dv18_voltage);
cr_store_sw_param32(adma_mode);
cr_store_sw_param8(lun_mode);
cr_store_sw_param32(otp_valid);
cr_store_sw_param8(dev_aspm_val);
cr_store_sw_param32(power_down_in_ss);
cr_store_sw_param32(baro_pkg);
cr_store_sw_param32(phy_debug_mode);
cr_store_sw_param32(aux_pwr_exist);
cr_store_sw_param8(ms_power_class_en);
cr_store_sw_param32(remote_wakeup_en);
cr_store_sw_param32(ss_idle_period);
cr_store_sw_param32(config_host_aspm);
cr_store_sw_param8(card_drive_sel);
cr_store_sw_param8(sd30_drive_sel_1v8);
cr_store_sw_param8(sd30_drive_sel_3v3);
cr_store_sw_param8(sd30_clk_drive_sel_1v8);
cr_store_sw_param8(sd30_cmd_drive_sel_1v8);
cr_store_sw_param8(sd30_dat_drive_sel_1v8);
cr_store_sw_param8(sd30_clk_drive_sel_3v3);
cr_store_sw_param8(sd30_cmd_drive_sel_3v3);
cr_store_sw_param8(sd30_dat_drive_sel_3v3);
cr_store_sw_param8(sd_400mA_ocp_thd);
cr_store_sw_param8(sd_800mA_ocp_thd);
cr_store_sw_param8(ms_ocp_thd);
cr_store_sw_param8(efuse_ldo_voltage);
cr_store_sw_param32(chk_int_en);
cr_store_sw_param32(led_reverse);
cr_store_sw_param32(led_period);
cr_store_sw_param32(msi_en);
cr_store_sw_param32(sd_timeout);
cr_store_sw_param32(sd40_timeout);
cr_store_sw_param32(xd_timeout);
cr_store_sw_param32(ms_timeout);
cr_store_sw_param32(mspro_timeout);
cr_store_sw_param32(auto_power_down);
cr_store_sw_param32(pmos_pwr_on_interval);
cr_store_sw_param32(sd_voltage_switch_delay);
cr_store_sw_param32(s3_pwr_off_delay);
cr_store_sw_param32(force_clkreq_0);
cr_store_sw_param32(ft2_fast_mode);
cr_store_sw_param32(do_delink_before_power_down);
cr_store_sw_param32(polling_config);
cr_store_sw_param32(delink_stage1_step);
cr_store_sw_param32(delink_stage2_step);
cr_store_sw_param32(delink_stage3_step);
cr_store_sw_param32(auto_delink_in_L1);
cr_store_sw_param32(safe_delink);
cr_store_sw_param32(hp_watch_bios_hotplug);
cr_store_sw_param32(support_ms_8bit);
cr_store_sw_param8(max_payload);
cr_store_sw_param32(sd_current_prior);
cr_store_sw_param32(sd_retry_cnt);
cr_store_sw_param32(sdio_retry_cnt);
cr_store_sw_param32(support_mmc);
cr_store_sw_param32(relink_time);
cr_store_sw_param32(pre_read_en);
cr_store_sw_param32(pre_read_th);
cr_store_sw_param32(sd40_nfcu);
cr_store_sw_param8(sd_io);
cr_store_sw_param8(sd_int);
cr_store_sw_param32(auto_delink_allowed);
cr_store_sw_param32(chip_insert_with_sdio);
cr_store_sw_param32(sdio_aspm);
cr_store_sw_param32(sdio_idle);
cr_store_sw_param32(sdio_counter);
cr_store_sw_param32(sdio_func_exist);
cr_store_sw_param32(sdio_in_charge);
cr_store_sw_param8(sd_sdr104_default_tx_phase);
cr_store_sw_param8(sd_sdr104_default_rx_phase);
cr_store_sw_param8(sd_sdr50_default_tx_phase);
cr_store_sw_param8(sd_sdr50_default_rx_phase);
cr_store_sw_param8(sd_ddr50_default_tx_phase);
cr_store_sw_param8(sd_ddr50_default_rx_phase);
cr_store_sw_param32(ltr_en);
cr_store_sw_param32(ltr_enabled);
cr_store_sw_param32(ltr_active);
cr_store_sw_param32(ltr_active_latency);
cr_store_sw_param32(ltr_idle_latency);
cr_store_sw_param32(ltr_l1off_latency);
cr_store_sw_param32(obff_en);
cr_store_sw_param32(obff_enabled);
cr_store_sw_param32(phy_optimize);
cr_store_sw_param8(ltr_l1off_sspwrgate);
cr_store_sw_param32(l1sub_fe49);
cr_store_sw_param32(phy03_bit5);
cr_store_sw_param32(aux_clk_freq);
cr_store_sw_param32(clk_req_bypass_short);
cr_store_sw_param32(ocp_en);
cr_store_sw_param32(write_clear_interrupt);
cr_store_sw_param8(ltr_l1off_snooze_sspwrgate);
cr_store_sw_param8(reg_0xfe76);
cr_store_sw_param8(sdr_tx_tuning_en);
cr_store_sw_param8(force_host_aspm_val);
cr_store_sw_param16(sd40_ebnum);
cr_store_sw_param8(card_spt_map);
cr_store_sw_param32(sd_capability);
cr_store_sw_param32(dev_aspm_mode);
cr_store_sw_param8(rtd3_en);
cr_store_sw_param32(l1_snooze_delay);
cr_store_sw_param32(n_lss_dir);
cr_store_sw_param32(dev_flags);
cr_store_sw_param32(sd_flags);
cr_store_sw_param32(ms_flags);
cr_store_sw_param32(patch_flags);
cr_store_sw_param32(delay_for_rw_reg);
cr_store_sw_param32(cprm_cmd_timeout);

/* store hw param */
cr_store_hw_param32(interrupt_en);
cr_store_hw_param8(ocp_glitch);
cr_store_hw_param8(av12s);
cr_store_hw_param8(eidle_num);
cr_store_hw_param16(phy0x00_val);
cr_store_hw_param16(phy0x02_val);
cr_store_hw_param16(phy0x01_val);
cr_store_hw_param16(phy0x03_val);
cr_store_hw_param16(phy0x05_val);
cr_store_hw_param16(phy0x08_val);
cr_store_hw_param16(phy0x19_val);
cr_store_hw_param16(phy0x1d_val);
cr_store_hw_param16(phy0x1e_val);
cr_store_hw_param16(phy0x1e_val_l1ss_off);
cr_store_hw_param16(phy0x82_val);
cr_store_hw_param16(phy0x85_val);
cr_store_hw_param16(phy0x87_val);
cr_store_hw_param16(phy0x88_val);
cr_store_hw_param16(phy0x90_val);
cr_store_hw_param16(phy0x92_val);

/* ATTR sw paramter */
CR_DRIVER_ATTR(mspro_formatter_enable);
CR_DRIVER_ATTR(fpga_sd_sdr104_clk);
CR_DRIVER_ATTR(fpga_sd_ddr50_clk);
CR_DRIVER_ATTR(fpga_sd_sdr50_clk);
CR_DRIVER_ATTR(fpga_sd_hs_clk);
CR_DRIVER_ATTR(fpga_mmc_52m_clk);
CR_DRIVER_ATTR(fpga_mmc_sdr200_clk);
CR_DRIVER_ATTR(fpga_ms_hg_clk);
CR_DRIVER_ATTR(fpga_ms_4bit_clk);
CR_DRIVER_ATTR(fpga_ms_1bit_clk);
CR_DRIVER_ATTR(asic_sd_sdr104_clk);
CR_DRIVER_ATTR(asic_sd_ddr50_clk);
CR_DRIVER_ATTR(asic_sd_sdr50_clk);
CR_DRIVER_ATTR(asic_sd_hs_clk);
CR_DRIVER_ATTR(asic_mmc_52m_clk);
CR_DRIVER_ATTR(asic_ms_hg_clk);
CR_DRIVER_ATTR(asic_ms_4bit_clk);
CR_DRIVER_ATTR(asic_ms_1bit_clk);
CR_DRIVER_ATTR(asic_mmc_sdr200_clk);
CR_DRIVER_ATTR(cd_debounce_time);
CR_DRIVER_ATTR(ssc_depth_sd_sdr104);
CR_DRIVER_ATTR(ssc_depth_sd_ddr50);
CR_DRIVER_ATTR(ssc_depth_sd_sdr50);
CR_DRIVER_ATTR(ssc_depth_sd_hs);
CR_DRIVER_ATTR(ssc_depth_mmc_52m);
CR_DRIVER_ATTR(ssc_depth_ms_hg);
CR_DRIVER_ATTR(ssc_depth_ms_4bit);
CR_DRIVER_ATTR(ssc_depth_low_speed);
CR_DRIVER_ATTR(mmc_ddr_tx_phase);
CR_DRIVER_ATTR(phase_min_cnt);
CR_DRIVER_ATTR(sd_speed_prior);
CR_DRIVER_ATTR(sd_ctl);
CR_DRIVER_ATTR(sd40_ctl);
CR_DRIVER_ATTR(ss_en);
CR_DRIVER_ATTR(ss_delay);
CR_DRIVER_ATTR(needs_remote_wakeup);
CR_DRIVER_ATTR(ww_enable);
CR_DRIVER_ATTR(ignore_sd);
CR_DRIVER_ATTR(use_hw_setting);
CR_DRIVER_ATTR(ssc_en);
CR_DRIVER_ATTR(auto_delink_en);
CR_DRIVER_ATTR(FT2_fast_mode);
CR_DRIVER_ATTR(pwr_delay);
CR_DRIVER_ATTR(xd_rw_step);
CR_DRIVER_ATTR(D3318_off_delay);
CR_DRIVER_ATTR(delink_delay);
CR_DRIVER_ATTR(rts5129_D3318_off_enable);
CR_DRIVER_ATTR(sd20_pad_drive);
CR_DRIVER_ATTR(sd30_pad_drive);
CR_DRIVER_ATTR(reset_or_rw_fail_set_pad_drive);
CR_DRIVER_ATTR(rcc_fail_flag);
CR_DRIVER_ATTR(rcc_bug_fix_en);
CR_DRIVER_ATTR(debounce_num);
CR_DRIVER_ATTR(polling_time);
CR_DRIVER_ATTR(polling_interval_run);
CR_DRIVER_ATTR(polling_interval_idle);
CR_DRIVER_ATTR(polling_interval_ss);
CR_DRIVER_ATTR(led_toggle_interval);
CR_DRIVER_ATTR(xd_rwn_step);
CR_DRIVER_ATTR(sd_send_status_en);
CR_DRIVER_ATTR(ms_errreg_fix);
CR_DRIVER_ATTR(reset_mmc_first);
CR_DRIVER_ATTR(speed_mmc);
CR_DRIVER_ATTR(blink_led);
CR_DRIVER_ATTR(led_blink_speed);
CR_DRIVER_ATTR(led_always_on);
CR_DRIVER_ATTR(dv18_voltage);
CR_DRIVER_ATTR(adma_mode);
CR_DRIVER_ATTR(lun_mode);
CR_DRIVER_ATTR(otp_valid);
CR_DRIVER_ATTR(dev_aspm_val);
CR_DRIVER_ATTR(power_down_in_ss);
CR_DRIVER_ATTR(baro_pkg);
CR_DRIVER_ATTR(phy_debug_mode);
CR_DRIVER_ATTR(aux_pwr_exist);
CR_DRIVER_ATTR(ms_power_class_en);
CR_DRIVER_ATTR(remote_wakeup_en);
CR_DRIVER_ATTR(ss_idle_period);
CR_DRIVER_ATTR(config_host_aspm);
CR_DRIVER_ATTR(card_drive_sel);
CR_DRIVER_ATTR(sd30_drive_sel_1v8);
CR_DRIVER_ATTR(sd30_drive_sel_3v3);
CR_DRIVER_ATTR(sd30_clk_drive_sel_1v8);
CR_DRIVER_ATTR(sd30_cmd_drive_sel_1v8);
CR_DRIVER_ATTR(sd30_dat_drive_sel_1v8);
CR_DRIVER_ATTR(sd30_clk_drive_sel_3v3);
CR_DRIVER_ATTR(sd30_cmd_drive_sel_3v3);
CR_DRIVER_ATTR(sd30_dat_drive_sel_3v3);
CR_DRIVER_ATTR(sd_400mA_ocp_thd);
CR_DRIVER_ATTR(sd_800mA_ocp_thd);
CR_DRIVER_ATTR(ms_ocp_thd);
CR_DRIVER_ATTR(efuse_ldo_voltage);
CR_DRIVER_ATTR(chk_int_en);
CR_DRIVER_ATTR(led_reverse);
CR_DRIVER_ATTR(led_period);
CR_DRIVER_ATTR(msi_en);
CR_DRIVER_ATTR(sd_timeout);
CR_DRIVER_ATTR(sd40_timeout);
CR_DRIVER_ATTR(xd_timeout);
CR_DRIVER_ATTR(ms_timeout);
CR_DRIVER_ATTR(mspro_timeout);
CR_DRIVER_ATTR(auto_power_down);
CR_DRIVER_ATTR(pmos_pwr_on_interval);
CR_DRIVER_ATTR(sd_voltage_switch_delay);
CR_DRIVER_ATTR(s3_pwr_off_delay);
CR_DRIVER_ATTR(force_clkreq_0);
CR_DRIVER_ATTR(ft2_fast_mode);
CR_DRIVER_ATTR(do_delink_before_power_down);
CR_DRIVER_ATTR(polling_config);
CR_DRIVER_ATTR(delink_stage1_step);
CR_DRIVER_ATTR(delink_stage2_step);
CR_DRIVER_ATTR(delink_stage3_step);
CR_DRIVER_ATTR(auto_delink_in_L1);
CR_DRIVER_ATTR(safe_delink);
CR_DRIVER_ATTR(hp_watch_bios_hotplug);
CR_DRIVER_ATTR(support_ms_8bit);
CR_DRIVER_ATTR(max_payload);
CR_DRIVER_ATTR(sd_current_prior);
CR_DRIVER_ATTR(sd_retry_cnt);
CR_DRIVER_ATTR(sdio_retry_cnt);
CR_DRIVER_ATTR(support_mmc);
CR_DRIVER_ATTR(relink_time);
CR_DRIVER_ATTR(pre_read_en);
CR_DRIVER_ATTR(pre_read_th);
CR_DRIVER_ATTR(sd40_nfcu);
CR_DRIVER_ATTR(sd_io);
CR_DRIVER_ATTR(sd_int);
CR_DRIVER_ATTR(auto_delink_allowed);
CR_DRIVER_ATTR(chip_insert_with_sdio);
CR_DRIVER_ATTR(sdio_aspm);
CR_DRIVER_ATTR(sdio_idle);
CR_DRIVER_ATTR(sdio_counter);
CR_DRIVER_ATTR(sdio_func_exist);
CR_DRIVER_ATTR(sdio_in_charge);
CR_DRIVER_ATTR(sd_sdr104_default_tx_phase);
CR_DRIVER_ATTR(sd_sdr104_default_rx_phase);
CR_DRIVER_ATTR(sd_sdr50_default_tx_phase);
CR_DRIVER_ATTR(sd_sdr50_default_rx_phase);
CR_DRIVER_ATTR(sd_ddr50_default_tx_phase);
CR_DRIVER_ATTR(sd_ddr50_default_rx_phase);
CR_DRIVER_ATTR(ltr_en);
CR_DRIVER_ATTR(ltr_enabled);
CR_DRIVER_ATTR(ltr_active);
CR_DRIVER_ATTR(ltr_active_latency);
CR_DRIVER_ATTR(ltr_idle_latency);
CR_DRIVER_ATTR(ltr_l1off_latency);
CR_DRIVER_ATTR(obff_en);
CR_DRIVER_ATTR(obff_enabled);
CR_DRIVER_ATTR(phy_optimize);
CR_DRIVER_ATTR(ltr_l1off_sspwrgate);
CR_DRIVER_ATTR(l1sub_fe49);
CR_DRIVER_ATTR(phy03_bit5);
CR_DRIVER_ATTR(aux_clk_freq);
CR_DRIVER_ATTR(clk_req_bypass_short);
CR_DRIVER_ATTR(ocp_en);
CR_DRIVER_ATTR(write_clear_interrupt);
CR_DRIVER_ATTR(ltr_l1off_snooze_sspwrgate);
CR_DRIVER_ATTR(reg_0xfe76);
CR_DRIVER_ATTR(sdr_tx_tuning_en);
CR_DRIVER_ATTR(force_host_aspm_val);
CR_DRIVER_ATTR(sd40_ebnum);
CR_DRIVER_ATTR(card_spt_map);
CR_DRIVER_ATTR(sd_capability);
CR_DRIVER_ATTR(dev_aspm_mode);
CR_DRIVER_ATTR(rtd3_en);
CR_DRIVER_ATTR(l1_snooze_delay);
CR_DRIVER_ATTR(n_lss_dir);
CR_DRIVER_ATTR(dev_flags);
CR_DRIVER_ATTR(sd_flags);
CR_DRIVER_ATTR(ms_flags);
CR_DRIVER_ATTR(patch_flags);
CR_DRIVER_ATTR(delay_for_rw_reg);
CR_DRIVER_ATTR(cprm_cmd_timeout);

/* ATTR hw param */
CR_DRIVER_ATTR(interrupt_en);
CR_DRIVER_ATTR(ocp_glitch);
CR_DRIVER_ATTR(av12s);
CR_DRIVER_ATTR(eidle_num);
CR_DRIVER_ATTR(phy0x00_val);
CR_DRIVER_ATTR(phy0x02_val);
CR_DRIVER_ATTR(phy0x01_val);
CR_DRIVER_ATTR(phy0x03_val);
CR_DRIVER_ATTR(phy0x05_val);
CR_DRIVER_ATTR(phy0x08_val);
CR_DRIVER_ATTR(phy0x19_val);
CR_DRIVER_ATTR(phy0x1d_val);
CR_DRIVER_ATTR(phy0x1e_val);
CR_DRIVER_ATTR(phy0x1e_val_l1ss_off);
CR_DRIVER_ATTR(phy0x82_val);
CR_DRIVER_ATTR(phy0x85_val);
CR_DRIVER_ATTR(phy0x87_val);
CR_DRIVER_ATTR(phy0x88_val);
CR_DRIVER_ATTR(phy0x90_val);
CR_DRIVER_ATTR(phy0x92_val);

static struct attribute *attrs_sw[] = {
	&driver_attr_mspro_formatter_enable.attr,
	&driver_attr_fpga_sd_sdr104_clk.attr,
	&driver_attr_fpga_sd_ddr50_clk.attr,
	&driver_attr_fpga_sd_sdr50_clk.attr,
	&driver_attr_fpga_sd_hs_clk.attr,
	&driver_attr_fpga_mmc_52m_clk.attr,
	&driver_attr_fpga_mmc_sdr200_clk.attr,
	&driver_attr_fpga_ms_hg_clk.attr,
	&driver_attr_fpga_ms_4bit_clk.attr,
	&driver_attr_fpga_ms_1bit_clk.attr,
	&driver_attr_asic_sd_sdr104_clk.attr,
	&driver_attr_asic_sd_ddr50_clk.attr,
	&driver_attr_asic_sd_sdr50_clk.attr,
	&driver_attr_asic_sd_hs_clk.attr,
	&driver_attr_asic_mmc_52m_clk.attr,
	&driver_attr_asic_ms_hg_clk.attr,
	&driver_attr_asic_ms_4bit_clk.attr,
	&driver_attr_asic_ms_1bit_clk.attr,
	&driver_attr_asic_mmc_sdr200_clk.attr,
	&driver_attr_cd_debounce_time.attr,
	&driver_attr_ssc_depth_sd_sdr104.attr,
	&driver_attr_ssc_depth_sd_ddr50.attr,
	&driver_attr_ssc_depth_sd_sdr50.attr,
	&driver_attr_ssc_depth_sd_hs.attr,
	&driver_attr_ssc_depth_mmc_52m.attr,
	&driver_attr_ssc_depth_ms_hg.attr,
	&driver_attr_ssc_depth_ms_4bit.attr,
	&driver_attr_ssc_depth_low_speed.attr,
	&driver_attr_mmc_ddr_tx_phase.attr,
	&driver_attr_phase_min_cnt.attr,
	&driver_attr_sd_speed_prior.attr,
	&driver_attr_sd_ctl.attr,
	&driver_attr_sd40_ctl.attr,
	&driver_attr_ss_en.attr,
	&driver_attr_ss_delay.attr,
	&driver_attr_needs_remote_wakeup.attr,
	&driver_attr_ww_enable.attr,
	&driver_attr_ignore_sd.attr,
	&driver_attr_use_hw_setting.attr,
	&driver_attr_ssc_en.attr,
	&driver_attr_auto_delink_en.attr,
	&driver_attr_FT2_fast_mode.attr,
	&driver_attr_pwr_delay.attr,
	&driver_attr_xd_rw_step.attr,
	&driver_attr_D3318_off_delay.attr,
	&driver_attr_delink_delay.attr,
	&driver_attr_rts5129_D3318_off_enable.attr,
	&driver_attr_sd20_pad_drive.attr,
	&driver_attr_sd30_pad_drive.attr,
	&driver_attr_reset_or_rw_fail_set_pad_drive.attr,
	&driver_attr_rcc_fail_flag.attr,
	&driver_attr_rcc_bug_fix_en.attr,
	&driver_attr_debounce_num.attr,
	&driver_attr_polling_time.attr,
	&driver_attr_polling_interval_run.attr,
	&driver_attr_polling_interval_idle.attr,
	&driver_attr_polling_interval_ss.attr,
	&driver_attr_led_toggle_interval.attr,
	&driver_attr_xd_rwn_step.attr,
	&driver_attr_sd_send_status_en.attr,
	&driver_attr_ms_errreg_fix.attr,
	&driver_attr_reset_mmc_first.attr,
	&driver_attr_speed_mmc.attr,
	&driver_attr_blink_led.attr,
	&driver_attr_led_blink_speed.attr,
	&driver_attr_led_always_on.attr,
	&driver_attr_dv18_voltage.attr,
	&driver_attr_adma_mode.attr,
	&driver_attr_lun_mode.attr,
	&driver_attr_otp_valid.attr,
	&driver_attr_dev_aspm_val.attr,
	&driver_attr_power_down_in_ss.attr,
	&driver_attr_baro_pkg.attr,
	&driver_attr_phy_debug_mode.attr,
	&driver_attr_aux_pwr_exist.attr,
	&driver_attr_ms_power_class_en.attr,
	&driver_attr_remote_wakeup_en.attr,
	&driver_attr_ss_idle_period.attr,
	&driver_attr_config_host_aspm.attr,
	&driver_attr_card_drive_sel.attr,
	&driver_attr_sd30_drive_sel_1v8.attr,
	&driver_attr_sd30_drive_sel_3v3.attr,
	&driver_attr_sd30_clk_drive_sel_1v8.attr,
	&driver_attr_sd30_cmd_drive_sel_1v8.attr,
	&driver_attr_sd30_dat_drive_sel_1v8.attr,
	&driver_attr_sd30_clk_drive_sel_3v3.attr,
	&driver_attr_sd30_cmd_drive_sel_3v3.attr,
	&driver_attr_sd30_dat_drive_sel_3v3.attr,
	&driver_attr_sd_400mA_ocp_thd.attr,
	&driver_attr_sd_800mA_ocp_thd.attr,
	&driver_attr_ms_ocp_thd.attr,
	&driver_attr_efuse_ldo_voltage.attr,
	&driver_attr_chk_int_en.attr,
	&driver_attr_led_reverse.attr,
	&driver_attr_led_period.attr,
	&driver_attr_msi_en.attr,
	&driver_attr_sd_timeout.attr,
	&driver_attr_sd40_timeout.attr,
	&driver_attr_xd_timeout.attr,
	&driver_attr_ms_timeout.attr,
	&driver_attr_mspro_timeout.attr,
	&driver_attr_auto_power_down.attr,
	&driver_attr_pmos_pwr_on_interval.attr,
	&driver_attr_sd_voltage_switch_delay.attr,
	&driver_attr_s3_pwr_off_delay.attr,
	&driver_attr_force_clkreq_0.attr,
	&driver_attr_ft2_fast_mode.attr,
	&driver_attr_do_delink_before_power_down.attr,
	&driver_attr_polling_config.attr,
	&driver_attr_delink_stage1_step.attr,
	&driver_attr_delink_stage2_step.attr,
	&driver_attr_delink_stage3_step.attr,
	&driver_attr_auto_delink_in_L1.attr,
	&driver_attr_safe_delink.attr,
	&driver_attr_hp_watch_bios_hotplug.attr,
	&driver_attr_support_ms_8bit.attr,
	&driver_attr_max_payload.attr,
	&driver_attr_sd_current_prior.attr,
	&driver_attr_sd_retry_cnt.attr,
	&driver_attr_sdio_retry_cnt.attr,
	&driver_attr_support_mmc.attr,
	&driver_attr_relink_time.attr,
	&driver_attr_pre_read_en.attr,
	&driver_attr_pre_read_th.attr,
	&driver_attr_sd40_nfcu.attr,
	&driver_attr_sd_io.attr,
	&driver_attr_sd_int.attr,
	&driver_attr_auto_delink_allowed.attr,
	&driver_attr_chip_insert_with_sdio.attr,
	&driver_attr_sdio_aspm.attr,
	&driver_attr_sdio_idle.attr,
	&driver_attr_sdio_counter.attr,
	&driver_attr_sdio_func_exist.attr,
	&driver_attr_sdio_in_charge.attr,
	&driver_attr_sd_sdr104_default_tx_phase.attr,
	&driver_attr_sd_sdr104_default_rx_phase.attr,
	&driver_attr_sd_sdr50_default_tx_phase.attr,
	&driver_attr_sd_sdr50_default_rx_phase.attr,
	&driver_attr_sd_ddr50_default_tx_phase.attr,
	&driver_attr_sd_ddr50_default_rx_phase.attr,
	&driver_attr_ltr_en.attr,
	&driver_attr_ltr_enabled.attr,
	&driver_attr_ltr_active.attr,
	&driver_attr_ltr_active_latency.attr,
	&driver_attr_ltr_idle_latency.attr,
	&driver_attr_ltr_l1off_latency.attr,
	&driver_attr_obff_en.attr,
	&driver_attr_obff_enabled.attr,
	&driver_attr_phy_optimize.attr,
	&driver_attr_ltr_l1off_sspwrgate.attr,
	&driver_attr_l1sub_fe49.attr,
	&driver_attr_phy03_bit5.attr,
	&driver_attr_aux_clk_freq.attr,
	&driver_attr_clk_req_bypass_short.attr,
	&driver_attr_ocp_en.attr,
	&driver_attr_write_clear_interrupt.attr,
	&driver_attr_ltr_l1off_snooze_sspwrgate.attr,
	&driver_attr_reg_0xfe76.attr,
	&driver_attr_sdr_tx_tuning_en.attr,
	&driver_attr_force_host_aspm_val.attr,
	&driver_attr_sd40_ebnum.attr,
	&driver_attr_card_spt_map.attr,
	&driver_attr_sd_capability.attr,
	&driver_attr_dev_aspm_mode.attr,
	&driver_attr_rtd3_en.attr,
	&driver_attr_l1_snooze_delay.attr,
	&driver_attr_n_lss_dir.attr,
	&driver_attr_dev_flags.attr,
	&driver_attr_sd_flags.attr,
	&driver_attr_ms_flags.attr,
	&driver_attr_patch_flags.attr,
	&driver_attr_delay_for_rw_reg.attr,
	&driver_attr_cprm_cmd_timeout.attr,
	NULL
};

static struct attribute *attrs_hw[] = {
	&driver_attr_interrupt_en.attr,
	&driver_attr_ocp_glitch.attr,
	&driver_attr_av12s.attr,
	&driver_attr_eidle_num.attr,
	&driver_attr_phy0x00_val.attr,
	&driver_attr_phy0x02_val.attr,
	&driver_attr_phy0x01_val.attr,
	&driver_attr_phy0x03_val.attr,
	&driver_attr_phy0x05_val.attr,
	&driver_attr_phy0x08_val.attr,
	&driver_attr_phy0x19_val.attr,
	&driver_attr_phy0x1d_val.attr,
	&driver_attr_phy0x1e_val.attr,
	&driver_attr_phy0x1e_val_l1ss_off.attr,
	&driver_attr_phy0x82_val.attr,
	&driver_attr_phy0x85_val.attr,
	&driver_attr_phy0x87_val.attr,
	&driver_attr_phy0x88_val.attr,
	&driver_attr_phy0x90_val.attr,
	&driver_attr_phy0x92_val.attr,
	NULL
};

static struct attribute_group attr_group_sw = {
	.name = "sw_param",
	.attrs = attrs_sw,

};

static struct attribute_group attr_group_hw = {
	.name = "hw_param",
	.attrs = attrs_hw,
};

const struct attribute_group *cr_driver_attr_groups[] = {
	&attr_group_sw,
	&attr_group_hw,
	NULL
};
EXPORT_SYMBOL_GPL(cr_driver_attr_groups);
