/* Driver for Realtek card reader
 *
 * Copyright(c) 2012 Realtek Semiconductor Corp. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *   edwin.rong(edwin_rong@realsil.com.cn)
 *   No. 450, Shenhu Road, Suzhou Industry Park, Suzhou, China
 *
 *   Tony.Nie(tony_nie@realsil.com.cn)
 *   No. 450, Shenhu Road, Suzhou Industry Park, Suzhou, China
 */

#include <linux/init.h>
#include <linux/module.h>
#include <linux/device.h>

#include "option.h"
#include "cardreader.h"

static int g_value = 12;
static ssize_t show_attr1(struct device_driver *driver, char *buf)
{
	return sprintf(buf, "%d\n", g_value);
}

static ssize_t store_attr1(struct device_driver *driver, const char *buf,
							size_t count)
{
	if (sscanf(buf, "%u", &g_value) == 1) {
		printk("g_value = %d\n", g_value);
		return count;
	}

	return -EINVAL;
}

static DRIVER_ATTR(attr1, S_IRUGO, show_attr1, store_attr1);

static ssize_t show_attr2(struct device_driver *driver, char *buf)
{
	return sprintf(buf, "%d\n", 0x55);
}

static DRIVER_ATTR(attr2, S_IRUGO, show_attr2, NULL);

static struct attribute *attrs1[] = {
	&driver_attr_attr1.attr,
	&driver_attr_attr2.attr,
	NULL
};

static struct attribute *attrs2[] = {
	&driver_attr_attr1.attr,
	&driver_attr_attr2.attr,
	NULL
};


static struct attribute_group attr_group1 = {
	.name = "attr_group1",
	.attrs = attrs1,
};

static struct attribute_group attr_group2 = {
	.name = "attr_group2",
	.attrs = attrs2,
};


const struct attribute_group *rts_cr_attr_groups[] = {
	&attr_group1,
	&attr_group2,
	NULL
};
EXPORT_SYMBOL_GPL(rts_cr_attr_groups);
