/* Driver for Realtek card reader
 * Header file
 *
 * Copyright(c) 2012 Realtek Semiconductor Corp. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *   edwin.rong(edwin_rong@realsil.com.cn)
 *   No. 450, Shenhu Road, Suzhou Industry Park, Suzhou, China
 *
 *   Tony.Nie(tony_nie@realsil.com.cn)
 *   No. 450, Shenhu Road, Suzhou Industry Park, Suzhou, China
 */

#ifndef RTS_CR_H
#define RTS_CR_H

#include <linux/blkdev.h>
#include <linux/completion.h>
#include <linux/mutex.h>
#include <linux/cdrom.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <scsi/scsi.h>
#include <scsi/scsi_cmnd.h>
#include <scsi/scsi_device.h>
#include <scsi/scsi_devinfo.h>
#include <scsi/scsi_eh.h>
#include <scsi/scsi_host.h>

#include "cardreader.h"

#define DRIVER_VERSION		"1.4.3"

#define RTS_CR_DESC		"Realtek PCIE Card Reader Driver"
#define RTS_CR_NAME		RTS_CR_DESC
#define CR_DRIVER_NAME		"rts_cr"
#define RTS_CR_CTL_THREAD	"rts_cr_control"
#define RTS_CR_POLLING_THREAD	"rts_cr_polling"
#define RTS_CR_SCAN_THREAD	"rts_cr_scan"


#define POLLING_IN_THREAD
/* #define SCSI_SCAN_DELAY */
/* #define SUPPORT_FILE_OP */ /* edwin: comment out */

struct cr_capability {
	struct list_head next;
	u16 pid;
	u16 vid;
	char *name;
	int extra_size; /* eg., equals sizeof(struct rts5139_info) */
	struct cr_callback callback;

	struct card_config_parameter **card_para;
	u8 num;

	struct card_conf card_conf;

	struct transport *tr;
	struct cr_patch *patch;
	struct list_head patch_line;
	void *drv_data;
};

int cr_register_capability(struct cr_capability *capability);
void cr_ungister_capabililty(u16 pid, u16 vid);
int rts_cr_pcie_probe(struct pci_dev *pci, const struct pci_device_id *id);
void rts_cr_pcie_remove(struct pci_dev *pci);
extern const struct attribute_group *rts_cr_attr_groups[];

#endif /* RTS_CR_H */
