#ifndef __SCSI_CMD_H__
#define __SCSI_CMD_H__

#include <asm/io.h>

/*---- PPSTATUS: function information----*/
#define PP_OC_LUN_STAT_SPRT		0x08
#define PP_WP_LUN_STAT_SPRT		0x20
#define PP_VBUS_INFO_SPRT		0x02
#define PP_CARD_VOLTAGE			0x08
#define pp_CARD_VOLTAGE_1V8		0x08

/*---- ppstatus: Function Supported ----*/
#define PP_SD_CPRM			0x08
#ifdef SUPPORT_MAGIC_GATE
#define PP_MAGIC_GATE			0x02
#else
#define PP_MAGIC_GATE			0x00
#endif

/*----ppstatus: AutoDelink mode----*/
#define PP_AUTO_DELINK_EN_DEF		0x10  /* auto-delink default enabled, not currently state*/

/*---- PPSTATUS: Warning status ----*/
#define PP_VBUS_TOO_LOW			0x02

/*---- PPSTATUS: Card Write Protect status ----*/
#define PP_LUN_WRITE_PROTECT		0x20
#define PP_LUN_READ_PROTECT		0x40

/*---- PPSTATUS: Code mode status ----*/
#define PP_FLASH_CODE			0x40
#define PP_CODE_MODE_FUNC		0x40
#define PP_FLASH_OP_VER2		0x02  /* Newer Flash Download mechanism */
#define	PP_USB_SPEED_FUNCTION_SUPPORT	0x08


/*---- PPSTATUS: SD Lock ----*/
#define PP_SD_LOCK_FUNC			0x01  /* For Byte 0x1F */
#define PP_SD_LOCK_SUPPORT		0x80  /* For Byte 0x17 */
#define PP_SD_ERASING			0x01  /* SD_UNDER_ERASING */
#define PP_SD_LOCKED			0x02
#define PP_SD_PWD_EXIST			0x04

/*---- PPSTATUS: SD/MMC Capacity/Speed information ----*/
#define PP_SD_SC			0x00
#define PP_SD_HC			0x01
#define PP_SD_XC			0x02
#define PP_SD_STD			0x00
#define PP_SD_HIGH			0x01
#define PP_SD_SDR50			0x02
#define PP_SD_SDR104			0x03
#define PP_SD_DDR50			0x04

#define PP_MMC_SC			0x00
#define PP_MMC_HC			0x01
#define PP_MMC_XC			0x02
#define PP_MMC_STD			0x00
#define PP_MMC_HIGH			0x01
#define PP_MMC_DDR50			0x04
int scsi_common_get_dev_sts(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_rd_mem(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_wr_mem(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_rd_sts(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_rd_phy_reg(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_wr_phy_reg(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_suit_rw_mem_cmd_buf(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_dma_rb(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_get_var(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_set_var(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_rd_cfg_byte(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_wr_cfg_byte(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_rd_host_reg(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_wr_host_reg(struct card_reader *cr, struct scsi_cmnd *srb);
int scsi_common_set_chip_mode(struct card_reader *cr, struct scsi_cmnd *srb);
void scsi_show_command(struct scsi_cmnd *srb);
void set_sense_type(struct card_reader *cr, u8 lun, int sense_type);
void set_sense_data(struct card_reader *cr, u8 lun, u8 err_code,
		    u8 sense_key, u32 info, u8 asc, u8 ascq, u8 sns_key_info0,
		    u16 sns_key_info1);

int scsi_handler(struct scsi_cmnd *srb, struct card_reader *cr);
int scsi_get_sector_info(struct scsi_cmnd *srb, u32 *lba, u16 *num);
int need_normal_power(struct scsi_cmnd *srb);

#endif /* __SCSI_CMD_H__*/
