/*++

THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

Copyright (c) Realtek Corporation. All rights reserved

Module Name:

    rtcf5227.c

Abstract:

    Pcie wdm driver (RTSPER) for PCIe cardreders (RTS5227 etc).

Environment:

    kernel mode only

Notes:


Revision History:
v1.00 2012-09-25 add by Moses.Yuan(moses_yuan@realsil.com.cn)

--*/

#include "RTCF5227.h"
#include "rtsmain.h"

struct cr_sd_ops rts5227_sd_ops_prot;
struct cr_ms_ops rts5227_ms_ops_prot;
struct cr_ops rts5227_ops;
struct cr_ops rts522a_ops;
struct cr_pm_ops rts5227_pm_ops;
struct cr_pm_ops rts522a_pm_ops;
struct cr_specific_cmd_handlers rts5227_specific_cmd_handlers;

void rts5227_sd_ops_prot_init(struct cr_sd_ops *rts5227_sd_ops_prot)
{
	rts5227_sd_ops_prot->init_power = rts5227_sd_init_power;
	rts5227_sd_ops_prot->pull_ctl_enable = rts5227_sd_pull_ctl_enable;
	rts5227_sd_ops_prot->pull_ctl_disable = rts5227_sd_pull_ctl_disable;
	rts5227_sd_ops_prot->current_over_limit400_handler =
		rts5227_sd_current_over_limit400_handler;
	rts5227_sd_ops_prot->disable = rts5227_sd_disable_card;
	rts5227_sd_ops_prot->release = rts5227_release_sd_card;
	rts5227_sd_ops_prot->update_status = rts5227_sd_update_report_status;
}

void rts5227_ms_ops_prot_init(struct cr_ms_ops *rts5227_ms_ops_prot)
{
	rts5227_ms_ops_prot->pull_ctl_enable = rts5227_ms_pull_ctl_enable;
	rts5227_ms_ops_prot->pull_ctl_disable = rts5227_ms_pull_ctl_disable;
	rts5227_ms_ops_prot->prepare_reset = rts5227_ms_prepare_reset;
	rts5227_ms_ops_prot->release = rts5227_release_ms_card;
}


void rts5227_ops_init(struct cr_ops *rts5227_ops)
{
	rts5227_ops->init_options = rts5227_init_options;
	rts5227_ops->init = rts5227_init;
	rts5227_ops->deal_extra_action = cr_deal_generic_extra_action;
	rts5227_ops->process_ocp = rts5227_process_ocp;
	rts5227_ops->init_ocp = rts5227_init_ocp;
}

void rts522a_ops_init(struct cr_ops *rts522a_ops)
{
	rts522a_ops->init_options = rts522a_init_options;
	rts522a_ops->init = rts5227_init;
	rts522a_ops->deal_extra_action = rts522a_deal_generic_extra_action;
	rts522a_ops->process_ocp = rts5227_process_ocp;
	rts522a_ops->init_ocp = rts5227_init_ocp;
}


void rts5227_pm_ops_init(struct cr_pm_ops *rts5227_pm_ops)
{
	rts5227_pm_ops->bef_pow_dwn = rts5227_before_power_down;
	rts5227_pm_ops->do_resume = rts5227_do_resume;
	/*rts5227_pm_ops->update_pm = rts5227_update_pm;
	rts5227_pm_ops->full_on = rts5227_pm_full_on;
	rts5227_pm_ops->power_saving = rts5227_pm_power_saving;
	rts5227_pm_ops->power_saving_max = rts5227_pm_power_saving_max;*/
	rts5227_pm_ops->enable_aspm = rts5227_enable_aspm;
	rts5227_pm_ops->disable_aspm = rts5227_disable_aspm;
	rts5227_pm_ops->do_before_auto_delink = rts5227_do_before_auto_delink;
}

void rts522a_pm_ops_init(struct cr_pm_ops *rts522a_pm_ops)
{
	rts522a_pm_ops->bef_pow_dwn = rts5227_before_power_down;
	rts522a_pm_ops->do_resume = rts5227_do_resume;
	rts522a_pm_ops->enable_aspm = rts5227_enable_aspm;
	rts522a_pm_ops->disable_aspm = rts5227_disable_aspm;
	rts522a_pm_ops->do_before_auto_delink = rts5227_do_before_auto_delink;
	rts522a_pm_ops->set_l1off_cfg_sub_D0 = rts522a_set_l1off_cfg_sub_D0;
	rts522a_pm_ops->full_on = rts522a_pm_full_on;
	rts522a_pm_ops->power_saving = rts522a_power_saving;
}

