/*++

THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

Copyright (c) Realtek Corporation. All rights reserved

Module Name:

    rtcf5227.h

Abstract:

    Pcie wdm driver (RTSPER) for PCIe cardreders (RTS5227 etc).

Environment:

    kernel mode only

Notes:


Revision History:
v1.00 2012-09-25 add by Moses.Yuan(moses_yuan@realsil.com.cn)

--*/

#ifndef _RTCF5227_H_
#define _RTCF5227_H_

extern struct cr_sd_ops rts5227_sd_ops_prot;
extern struct cr_ms_ops rts5227_ms_ops_prot;
extern struct cr_ops rts5227_ops;
extern struct cr_ops rts522a_ops;
extern struct cr_pm_ops rts5227_pm_ops;
extern struct cr_pm_ops rts522a_pm_ops;
extern struct cr_specific_cmd_handlers rts5227_specific_cmd_handlers;

void rts5227_sd_ops_prot_init(struct cr_sd_ops *rts5227_sd_ops_prot);
void rts5227_ms_ops_prot_init(struct cr_ms_ops *rts5227_ms_ops_prot);
void rts5227_specific_cmd_handlers_init(
	struct cr_specific_cmd_handlers *rts5227_specific_cmd_handlers);
void rts5227_ops_init(struct cr_ops *rts5227_ops);
void rts5227_pm_ops_init(struct cr_pm_ops *rts5227_pm_ops);
void rts522a_pm_ops_init(struct cr_pm_ops *rts522a_pm_ops);
void rts522a_ops_init(struct cr_ops *rts522a_ops);


#endif
