/*++

THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

Copyright (c) Realtek Corporation. All rights reserved

Module Name:

    RTCF5249.c

Abstract:

    Pcie wdm driver (RTSPER) for PCIe cardreders (RTS5227 etc).

Environment:

    kernel mode only

Notes:


Revision History:
v1.00 2012-09-25 add by Moses.Yuan(moses_yuan@realsil.com.cn)

--*/

#include "rtcf5249.h"
#include "rtsmain.h"

struct cr_sd_ops rts5249_sd_ops_prot;
struct cr_ms_ops rts5249_ms_ops_prot;
struct cr_ops rts5249_ops;
struct cr_pm_ops rts5249_pm_ops;
struct cr_specific_cmd_handlers rts5249_specific_cmd_handlers;
struct cr_sd_ops rts5250_sd_ops_prot;
struct cr_ops rts5250_ops;
struct cr_pm_ops rts5250_pm_ops;
struct cr_sd_ops rts524a_sd_ops_prot;
struct cr_ops rts524a_ops;
struct cr_pm_ops rts524a_pm_ops;
struct cr_ops rts525a_ops;


void rts5249_xd_ops_init(struct cr_card_ops *rts5249_xd_ops)
{

}

void rts5249_ms_ops_prot_init(struct cr_ms_ops *rts5249_ms_ops_prot)
{
	rts5249_ms_ops_prot->pull_ctl_disable = rts5249_ms_pull_ctl_disable;
	rts5249_ms_ops_prot->pull_ctl_enable = rts5249_ms_pull_ctl_enable;
	rts5249_ms_ops_prot->release = rts5249_release_ms_card;
}

void rts5249_xd_ops_prot_init(struct cr_ms_ops *rts5249_ms_ops_prot)
{
}

void rts5249_sd_ops_prot_init(struct cr_sd_ops *rts5249_sd_ops_prot)
{
	rts5249_sd_ops_prot->init_power = rts5249_sd_init_power;
	rts5249_sd_ops_prot->cleanup = rts5249_sd_cleanup_work;
	rts5249_sd_ops_prot->release = rts5249_release_sd_card;
	rts5249_sd_ops_prot->current_over_limit400_handler =
		rts5249_sd_current_over_limit400_handler;
	rts5249_sd_ops_prot->chg_bank_volt = rts5249_sd_change_bank_voltage;
	rts5249_sd_ops_prot->pull_ctl_disable = rts5249_sd_pull_ctl_disable;
	rts5249_sd_ops_prot->pull_ctl_enable = rts5249_sd_pull_ctl_enable;
	rts5249_sd_ops_prot->init_sd40_hw = rts5249_init_sd40_hw;
	rts5249_sd_ops_prot->init_sd40_hw_m = rts5249_init_sd40_hw_m;
	rts5249_sd_ops_prot->uninit_sd40_hw = rts5249_uninit_sd40_hw;
	rts5249_sd_ops_prot->process_dormannt_state =
				rts5249_process_sd40_dormant_state;
	rts5249_sd_ops_prot->stop_sequential = rts5249_sd_stop_sequential;
	rts5249_sd_ops_prot->patch_special_card = rts5249_patch_special_sd;
	rts5249_sd_ops_prot->set_power_control_mode =
			rts5249_sd40_set_power_control_mode;
	rts5249_sd_ops_prot->take_sd40_init =
		rts5249_sd40_take_dev_init_process;
	rts5249_sd_ops_prot->prepare_reset = rts5249_sd_prepare_reset;
	rts5249_sd_ops_prot->set_sd40_n_fcu = rts5249_sd40_set_n_fcu;
}

void rts5250_sd_ops_prot_init(struct cr_sd_ops *rts5250_sd_ops_prot)
{
	rts5250_sd_ops_prot->init_power = rts5250_sd_init_power;
	rts5250_sd_ops_prot->cleanup = rts5249_sd_cleanup_work;
	rts5250_sd_ops_prot->release = rts5249_release_sd_card;
	rts5250_sd_ops_prot->current_over_limit400_handler =
		rts5250_sd_current_over_limit400_handler;
	rts5250_sd_ops_prot->chg_bank_volt = rts5250_sd_change_bank_voltage;
	rts5250_sd_ops_prot->pull_ctl_disable = rts5249_sd_pull_ctl_disable;
	rts5250_sd_ops_prot->pull_ctl_enable = rts5249_sd_pull_ctl_enable;
	rts5250_sd_ops_prot->init_sd40_hw = rts5249_init_sd40_hw;
	rts5250_sd_ops_prot->init_sd40_hw_m = rts5249_init_sd40_hw_m;
	rts5250_sd_ops_prot->uninit_sd40_hw = rts5249_uninit_sd40_hw;
	rts5250_sd_ops_prot->process_dormannt_state =
				rts5249_process_sd40_dormant_state;
	rts5250_sd_ops_prot->stop_sequential = rts5249_sd_stop_sequential;
	rts5250_sd_ops_prot->patch_special_card = rts5249_patch_special_sd;
	rts5250_sd_ops_prot->set_power_control_mode =
			rts5250_sd40_set_power_control_mode;
	rts5250_sd_ops_prot->take_sd40_init =
		rts5249_sd40_take_dev_init_process;
	rts5250_sd_ops_prot->prepare_reset = rts5249_sd_prepare_reset;
}

void rts5249_specific_cmd_handlers_init(
	struct cr_specific_cmd_handlers *rts5249_specific_cmd_handlers)
{

}

void rts5249_ops_init(struct cr_ops *rts5249_ops)
{
	rts5249_ops->init_options = rts5249_init_options;
	rts5249_ops->init = rts5249_init;
	rts5249_ops->detect_card = rts5249_detect_card;
	rts5249_ops->poweron_card = rts5249_poweron_card;
	rts5249_ops->poweroff_card = rts5249_poweroff_card;
	rts5249_ops->switch_to_sdio = rts5249_switch_to_sdio_ctrl;
	rts5249_ops->clear_ocpstat = rts5249_clear_ocpstat;
	rts5249_ops->get_ocpstat = rts5249_get_ocpstat;
	rts5249_ops->enable_ocp = rts5249_enable_ocp;
	rts5249_ops->disable_ocp = rts5249_disable_ocp;
	rts5249_ops->init_ocp = rts5249_init_ocp;
	rts5249_ops->deal_extra_action = cr_deal_generic_extra_action;
	rts5249_ops->enable_dma = rts5249_enable_dma;
}

void rts524a_ops_init(struct cr_ops *rts524a_ops)
{
	rts524a_ops->init_options = rts524a_init_options;
	rts524a_ops->init = rts5249_init;
	rts524a_ops->detect_card = rts5249_detect_card;
	rts524a_ops->poweron_card = rts5249_poweron_card;
	rts524a_ops->poweroff_card = rts5249_poweroff_card;
	rts524a_ops->switch_to_sdio = rts5249_switch_to_sdio_ctrl;
	rts524a_ops->clear_ocpstat = rts5249_clear_ocpstat;
	rts524a_ops->get_ocpstat = rts5249_get_ocpstat;
	rts524a_ops->enable_ocp = rts5249_enable_ocp;
	rts524a_ops->disable_ocp = rts5249_disable_ocp;
	rts524a_ops->init_ocp = rts5249_init_ocp;
	rts524a_ops->deal_extra_action = rts524a_deal_generic_extra_action;
	rts524a_ops->enable_dma = rts5249_enable_dma;
	rts524a_ops->process_ocp = rts5250_process_ocp;
	rts524a_ops->rd_phy16 = rts524a_rd_phy16;
	rts524a_ops->wr_phy16 = rts524a_wr_phy16;
}

void rts525a_ops_init(struct cr_ops *rts525a_ops)
{
	rts525a_ops->init_options = rts525a_init_options;
	rts525a_ops->init = rts5249_init;
	rts525a_ops->detect_card = rts5249_detect_card;
	rts525a_ops->poweron_card = rts5250_poweron_card;
	rts525a_ops->poweroff_card = rts5249_poweroff_card;
	rts525a_ops->clear_ocpstat = rts5249_clear_ocpstat;
	rts525a_ops->get_ocpstat = rts5249_get_ocpstat;
	rts525a_ops->enable_ocp = rts5249_enable_ocp;
	rts525a_ops->disable_ocp = rts5249_disable_ocp;
	rts525a_ops->init_ocp = rts5249_init_ocp;
	rts525a_ops->deal_extra_action = rts5250_deal_generic_extra_action;
	rts525a_ops->enable_dma = rts5249_enable_dma;
	rts525a_ops->process_ocp = rts5250_process_ocp;
	rts525a_ops->enable_oobs_polling = rts525a_enable_oobs_polling;
	rts525a_ops->disable_oobs_polling = rts525a_disable_oobs_polling;
}

void rts5250_ops_init(struct cr_ops *rts5250_ops)
{
	rts5250_ops->init_options = rts5250_init_options;
	rts5250_ops->init = rts5249_init;
	rts5250_ops->detect_card = rts5249_detect_card;
	rts5250_ops->poweron_card = rts5250_poweron_card;
	rts5250_ops->poweroff_card = rts5249_poweroff_card;
	rts5250_ops->switch_to_sdio = rts5249_switch_to_sdio_ctrl;
	rts5250_ops->clear_ocpstat = rts5249_clear_ocpstat;
	rts5250_ops->get_ocpstat = rts5249_get_ocpstat;
	rts5250_ops->enable_ocp = rts5249_enable_ocp;
	rts5250_ops->disable_ocp = rts5249_disable_ocp;
	rts5250_ops->init_ocp = rts5249_init_ocp;
	rts5250_ops->deal_extra_action = rts5250_deal_generic_extra_action;
	rts5250_ops->enable_dma = rts5249_enable_dma;
	rts5250_ops->process_ocp = rts5250_process_ocp;
	rts5250_ops->patch_dma = rts5250_patch_dma;
}

void rts5249_pm_ops_init(struct cr_pm_ops *rts5249_pm_ops)
{
	rts5249_pm_ops->bef_pow_dwn = rts5249_before_power_down;
	rts5249_pm_ops->do_resume = rts5249_do_resume;
	rts5249_pm_ops->enable_aspm = rts5249_enable_aspm;
	rts5249_pm_ops->disable_aspm = rts5249_disable_aspm;
	rts5249_pm_ops->do_before_auto_delink = rts5249_do_before_auto_delink;
}

void rts524a_pm_ops_init(struct cr_pm_ops *rts524a_pm_ops)
{
	rts524a_pm_ops->bef_pow_dwn = rts5249_before_power_down;
	rts524a_pm_ops->do_resume = rts5249_do_resume;
	rts524a_pm_ops->enable_aspm = rts5249_enable_aspm;
	rts524a_pm_ops->disable_aspm = rts5249_disable_aspm;
	rts524a_pm_ops->do_before_auto_delink = rts5249_do_before_auto_delink;
	rts524a_pm_ops->set_l1off_cfg_sub_D0 = rts5250_set_l1off_cfg_sub_D0;
	rts524a_pm_ops->power_saving = rts522a_power_saving;
	rts524a_pm_ops->full_on = rts5250_pm_full_on;
}


void rts5250_pm_ops_init(struct cr_pm_ops *rts5250_pm_ops)
{
	rts5250_pm_ops->bef_pow_dwn = rts5249_before_power_down;
	rts5250_pm_ops->do_resume = rts5249_do_resume;
	rts5250_pm_ops->enable_aspm = rts5249_enable_aspm;
	rts5250_pm_ops->disable_aspm = rts5249_disable_aspm;
	rts5250_pm_ops->do_before_auto_delink = rts5249_do_before_auto_delink;
	rts5250_pm_ops->set_l1off_cfg_sub_D0 = rts5250_set_l1off_cfg_sub_D0;
	rts5250_pm_ops->full_on = rts5250_pm_full_on;
}

void rts524a_sd_ops_prot_init(struct cr_sd_ops *rts524a_sd_ops_prot)
{
	rts524a_sd_ops_prot->init_power = rts5249_sd_init_power;
	rts524a_sd_ops_prot->cleanup = rts5249_sd_cleanup_work;
	rts524a_sd_ops_prot->release = rts5249_release_sd_card;
	rts524a_sd_ops_prot->current_over_limit400_handler =
		rts5249_sd_current_over_limit400_handler;
	rts524a_sd_ops_prot->chg_bank_volt = rts5249_sd_change_bank_voltage;
	rts524a_sd_ops_prot->pull_ctl_disable = rts5249_sd_pull_ctl_disable;
	rts524a_sd_ops_prot->pull_ctl_enable = rts5249_sd_pull_ctl_enable;
	rts524a_sd_ops_prot->init_sd40_hw = rts5249_init_sd40_hw;
	rts524a_sd_ops_prot->init_sd40_hw_m = rts5249_init_sd40_hw_m;
	rts524a_sd_ops_prot->uninit_sd40_hw = rts5249_uninit_sd40_hw;
	rts524a_sd_ops_prot->process_dormannt_state =
				rts5249_process_sd40_dormant_state;
	rts524a_sd_ops_prot->stop_sequential = rts5249_sd_stop_sequential;
	rts524a_sd_ops_prot->patch_special_card = rts5249_patch_special_sd;
	rts524a_sd_ops_prot->set_power_control_mode =
			rts5250_sd40_set_power_control_mode;
	rts524a_sd_ops_prot->take_sd40_init =
		rts5249_sd40_take_dev_init_process;
	rts524a_sd_ops_prot->prepare_reset = rts5249_sd_prepare_reset;
}

