/*++

THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

Copyright (c) Realtek Corporation. All rights reserved

Module Name:

    RTCF5249.h

Abstract:

    Pcie wdm driver (RTSPER) for PCIe cardreders (RTS5227 etc).

Environment:

    kernel mode only

Notes:


Revision History:
v1.00 2012-09-25 add by Moses.Yuan(moses_yuan@realsil.com.cn)

--*/

#ifndef _RTCF5249_H_
#define _RTCF5249_H_

extern struct cr_sd_ops rts5249_sd_ops_prot;
extern struct cr_ms_ops rts5249_ms_ops_prot;
extern struct cr_ops rts5249_ops;
extern struct cr_pm_ops rts5249_pm_ops;
extern struct cr_specific_cmd_handlers rts5249_specific_cmd_handlers;
extern struct cr_sd_ops rts5250_sd_ops_prot;
extern struct cr_ops rts5250_ops;
extern struct cr_pm_ops rts5250_pm_ops;
extern struct cr_sd_ops rts524a_sd_ops_prot;
extern struct cr_ops rts524a_ops;
extern struct cr_pm_ops rts524a_pm_ops;
extern struct cr_ops rts525a_ops;



void rts5249_xd_ops_init(struct cr_card_ops *rts5249_xd_ops);
void rts5249_ms_ops_prot_init(struct cr_ms_ops *rts5249_ms_ops_prot);
void rts5249_xd_ops_prot_init(struct cr_ms_ops *rts5249_ms_ops_prot);
void rts5249_sd_ops_prot_init(struct cr_sd_ops *rts5249_sd_ops_prot);
void rts5249_specific_cmd_handlers_init(
	struct cr_specific_cmd_handlers *rts5249_specific_cmd_handlers);
void rts5249_ops_init(struct cr_ops *rts5249_ops);
void rts5249_pm_ops_init(struct cr_pm_ops *rts5249_pm_ops);
void rts5250_sd_ops_prot_init(struct cr_sd_ops *rts5249_sd_ops_prot);
void rts5250_ops_init(struct cr_ops *rts5250_ops);
void rts5250_pm_ops_init(struct cr_pm_ops *rts5250_pm_ops);

void rts524a_ops_init(struct cr_ops *rts524a_ops);
void rts524a_sd_ops_prot_init(struct cr_sd_ops *rts524a_sd_ops_prot);
void rts524a_pm_ops_init(struct cr_pm_ops *rts524a_pm_ops);

void rts525a_ops_init(struct cr_ops *rts525a_ops);



#endif
