/*++

THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

Copyright (c) Realtek Corporation. All rights reserved

Module Name:

    rtcf8411.c

Abstract:

    Pcie wdm driver (RTSPER) for PCIe cardreders (RTL8411 etc).

Environment:

    kernel mode only

Notes:


Revision History:
v1.00 2012-09-25 add by Moses.Yuan(moses_yuan@realsil.com.cn)

--*/

#include "RTCF8411.h"
#include "rtsmain.h"

struct cr_sd_ops rtl8411_sd_ops_prot;
struct cr_ms_ops rtl8411_ms_ops_prot;
struct cr_ops rtl8411_ops;
struct cr_pm_ops rtl8411_pm_ops;
struct cr_specific_cmd_handlers rtl8411_specific_cmd_handlers;


void rtl8411_sd_ops_prot_init(struct cr_sd_ops *rtl8411_sd_ops_prot)
{
	rtl8411_sd_ops_prot->init_power = rtl8411_sd_init_power;
	rtl8411_sd_ops_prot->pull_ctl_enable = rtl8411_sd_pull_ctl_enable;
	rtl8411_sd_ops_prot->pull_ctl_disable = rtl8411_sd_pull_ctl_disable;
	rtl8411_sd_ops_prot->disable = rtl8411_sd_disable_card;
	rtl8411_sd_ops_prot->release = rtl8411_release_sd_card;
	rtl8411_sd_ops_prot->update_status = rtl8411_sd_update_report_status;
	rtl8411_sd_ops_prot->chg_bank_volt = rtl8411_sd_change_bank_voltage;
	rtl8411_sd_ops_prot->current_over_limit400_handler =
		rtl8411_sd_current_over_limit400_handler;
	rtl8411_sd_ops_prot->sd30_drive_sel = rtl8411_sd30_drive_sel;
}

void rtl8411_ms_ops_prot_init(struct cr_ms_ops *rtl8411_ms_ops_prot)
{
	rtl8411_ms_ops_prot->pull_ctl_enable = rtl8411_ms_pull_ctl_enable;
	rtl8411_ms_ops_prot->pull_ctl_disable = rtl8411_ms_pull_ctl_disable;
	rtl8411_ms_ops_prot->release = rtl8411_release_ms_card;
}


void rtl8411_ops_init(struct cr_ops *rtl8411_ops)
{
	rtl8411_ops->init_options = rtl8411_init_options;
	rtl8411_ops->init = rtl8411_init;
	rtl8411_ops->poweron_card = rtl8411_poweron_card;
	rtl8411_ops->poweroff_card = rtl8411_power_off_card;
	rtl8411_ops->cd_deglitch = rtl8411_cd_deglitch;
	rtl8411_ops->get_ocpstat = rtl8411_get_ocpstat;
	rtl8411_ops->clear_ocpstat = rtl8411_clear_ocpstat;
	rtl8411_ops->enable_ocp = rtl8411_enable_ocp;
	rtl8411_ops->disable_ocp = rtl8411_disable_ocp;
	rtl8411_ops->init_ocp = rtl8411_init_ocp;

	rtl8411_ops->turn_on_led = rtl8411_turn_on_led;
	rtl8411_ops->turn_off_led = rtl8411_turn_off_led;
	rtl8411_ops->enable_auto_blink = rtl8411_enable_auto_blink;
	rtl8411_ops->disable_auto_blink = rtl8411_disable_auto_blink;
	rtl8411_ops->calc_ssc_clock_N = rtl8411_calc_ssc_clock_N;
	rtl8411_ops->deal_extra_action = rtl8411_deal_extra_action;
}

void rtl8411_pm_ops_init(struct cr_pm_ops *rtl8411_pm_ops)
{
	rtl8411_pm_ops->bef_pow_dwn = rtl8411_before_power_down;
	rtl8411_pm_ops->do_resume = rtl8411_do_resume;
	rtl8411_pm_ops->enable_aspm = rtl8411_enable_aspm;
	rtl8411_pm_ops->disable_aspm = rtl8411_disable_aspm;
	rtl8411_pm_ops->force_power_on = rtl8411_force_power_on;
	rtl8411_pm_ops->force_power_down = rtl8411_force_power_down;
	rtl8411_pm_ops->set_ltr_latency = rtl8411_set_ltr_latency;
	rtl8411_pm_ops->set_l1off_sub = rtl8411_set_l1off_sub;
	rtl8411_pm_ops->power_saving_max = rtl8411_power_saving_max;
}
