/*++

THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
PARTICULAR PURPOSE.

Copyright (c) Realtek Corporation. All rights reserved

Module Name:

    rtcf8411.h

Abstract:

    Pcie wdm driver (RTSPER) for PCIe cardreders (RTL8411 etc).

Environment:

    kernel mode only

Notes:


Revision History:
v1.00 2012-09-25 add by Moses.Yuan(moses_yuan@realsil.com.cn)

--*/

#ifndef _RTCF8411_H_
#define _RTCF8411_H_

extern struct cr_sd_ops rtl8411_sd_ops_prot;
extern struct cr_ms_ops rtl8411_ms_ops_prot;
extern struct cr_ops rtl8411_ops;
extern struct cr_pm_ops rtl8411_pm_ops;
extern struct cr_specific_cmd_handlers rtl8411_specific_cmd_handlers;

void rtl8411_sd_ops_prot_init(struct cr_sd_ops *rtl8411_sd_ops_prot);
void rtl8411_ms_ops_prot_init(struct cr_ms_ops *rtl8411_ms_ops_prot);
void rtl8411_specific_cmd_handlers_init(
	struct cr_specific_cmd_handlers *rtl8411_specific_cmd_handlers);
void rtl8411_ops_init(struct cr_ops *rtl8411_ops);
void rtl8411_pm_ops_init(struct cr_pm_ops *rtl8411_pm_ops);

#endif
