#ifndef __RTS5249_H__
#define __RTS5249_H__


#define REG_ARG_IOADR_L				RTS5249_SD40_ARG1


#define RTS5249_SD40_MISC			0xEC34

#define REG_SD40_TBASE_L			0xEC35
#define REG_SD40_TBASE_H			0xEC36
#define REG_TMO_DIDLE_STB			0xEC37
#define REG_TMO_ACTV_INIT_L			0xEC38
#define REG_TMO_ACTV_INIT_H			0xEC39
#define REG_TMO_ACTV_NRML			0xEC3A
#define REG_TMO_DINI_CMD_L			0xEC3B
#define REG_TMO_DINI_CMD_H			0xEC3C
#define REG_TMO_CMD_RES				0xEC3D
#define REG_TMO_RES_FCREQ_L			0xEC3E
#define REG_TMO_RES_FCREQ_H			0xEC3F
#define REG_TMO_FCREQ_FCRDY_L			0xEC40
#define REG_TMO_FCREQ_FCRDY_H			0xEC41
#define REG_TMO_FCRDY_EDB_L			0xEC42
#define REG_TMO_FCRDY_EDB_H			0xEC43
#define REG_EIDL_IN_OUT_CNT			0xEC44
#define REG_DIR_SW_CLK_CNT			0xEC45
#define REG_RD_SYN_CLK_CNT			0xEC46
#define REG_PCMD_DELAY_CNT			0xEC47


#define REG_SD40_ENTLPBK			0xEC4A


#define REG_SD40_ERR_EN				0xEC50

#define RTS5250_HOST_CTL2			0xF03F
#define RTS5250_ADMA2_LENGTH_MASK		0x04
#define RTS5250_ADMA2_LENGTH_16BIT		0x00
#define RTS5250_ADMA2_LENGTH_26BIT		0x04

#define RTS5249_SDIO_MUX_CTL			0xFD6F

/* card CD control register */
#define RTS5249_CD_PAD_CTL			0xFD73
#define RTS5249_CD_DISABLE_MASK			0x07
#define RTS5249_MS_CD_DISABLE			0x04
#define RTS5249_SD_CD_DISABLE			0x02
#define RTS5249_XD_CD_DISABLE			0x01
#define RTS5249_CD_DISABLE			0x07
#define RTS5249_CD_ENABLE			0x00
#define RTS5249_MS_CD_EN_ONLY			0x03
#define RTS5249_SD_CD_EN_ONLY			0x05
#define RTS5249_XD_CD_EN_ONLY			0x06
#define RTS5249_FORCE_CD_LOW_MASK		0x38
#define RTS5249_FORCE_CD_XD_LOW			0x08
#define RTS5249_FORCE_CD_SD_LOW			0x10
#define RTS5249_FORCE_CD_MS_LOW			0x20
#define RTS5249_CD_AUTO_DISABLE			0x40

#define MODE_CONFIG_REG			0xFE5E
#define RX_AMP_OFFSET_AUTOK_EN			0x08
#define LOAD_EFUSE_MODE			0x02

#define RTS5249_SD40_LDO_CTL			0xFE7C
#define SD40_VCC_TUNE_MASK			0xE0
#define SD_VCC_LDO_18V				0x40
#define SD_VCC_LDO_33V				0xE0
#define SD40_LDO12_MASK				(0x07 << 2)
#define SD40_LDO_AV12S_1_15V			(0x03 << 2)
#define SD40_LDO12AS_MASK			0x03
#define SD40_LD012AS_OFF			0x00
#define SD40_LD012AS_ON_ALL			0x03
#define SD40_LD012AS_ON_PL			0x01

#define RTS5250_SD40_LDO_CTL1			0xFE7D
#define SD40_VIO_TUNE_MASK			0x70
#define SD40_VIO_TUNE_1V7			0x30
#define SD_VIO_LDO_18V				0x40
#define SD_VIO_LDO_33V				0x70
#define SD_VCC_PD_MASK				0x03


#define RTS5249_SD40_PAD_ISO			0x80
#define RTS5249_SD40_PAD_ISO_DEFAULT		0x00

#define RTS5249_SD_VIO_PWR_MASK			0x0C
#define RTS5249_SD_VIO_PWR_OFF			0x0C
#define RTS5249_SD_VIO_PWR14_ON			0x08
#define RTS5249_SD_VIO_PWR_ON			0x00

#define RTS5249_SD_POWER_MASK			0x03
#define RTS5249_SD_POWER_OFF			0x03
#define RTS5249_SD_PWR14_ON			0x02
#define RTS5249_SD_POWER_ON			0x00

/* Card Clock Enable Register */

/* card clock control register*/
#define RTS5249_CHANGE_CLK			0x01
#define RTS5249_CHANGE_SD40_PCLK		0x02

#define RTS5249_SD_OCP_THD_620			0x00
#define RTS5249_SD_OCP_THD_700			0x01
#define RTS5249_SD_OCP_THD_770			0x02
#define RTS5249_SD_OCP_THD_850			0x03
#define RTS5249_SD_OCP_THD_920			0x04
#define RTS5249_SD_OCP_THD_1060			0x05
#define RTS5249_SD_OCP_THD_1220			0x06
#define RTS5249_SD_OCP_THD_1360			0x07
#define RTS5249_SD_OCP_THD_MASK			0x07

#define RTS5249_DMA_PACK_SIZE_MASK		0x70

#define REG_VREF				0xFE97
#define   PWD_SUSPND_EN				(1 << 4)

#define RTS525A_BIOS_CFG			0xFF2D
#define RTS525A_LOAD_BIOS_FLAG			0x01
#define RTS525A_CLEAR_BIOS_FLAG			0x00

#define RTS525A_PCIE_OFFSET_K_CFG		0xFF6D
#define RTS525A_PCIE_OFFSET_K_MASK		0x0F
#define RTS525A_PCIE_OFFSET_K_DIS		0x80

#define RTS525A_RREF_CFG			0xFF6C
#define REG_VBGSEL_MASK			0x38
#define REG_VBGSEL_1V25			0x28

#define RTS525A_OOBS_CFG			0xFF6E
#define REG_OOBS_AUTOK_DIS			0x80
#define REG_OOBS_VAL_MASK			0x1F

#define RTS525A_LDO_DV18_CFG		0xFF70
#define REG_DV18_SR_MASK			0xC0
#define REG_DV18_SR_DF				0x40

#define RTS525A_LDO_VCC_CFG0			0xFF72
#define REG_SDVCC_LMTVTH_MASK			0x30
#define REG_SDVCC_LMTVTH_2A			0x10

#define RTS525A_LDO_VCC_CFG1			0xFF73
#define REG_TUNEREF_VCC_MASK		0x30
#define REG_TUNEREF_VCC_1V2			0x20
#define REG_TUNE_VCC_MASK			0x07
#define REG_LDO_VCC_18V				0x04
#define REG_LDO_VCC_33V				0x07
#define REG_LMT_EN			0x08
#define RTS525A_SD_VCC_PD_MASK			0xC0

#define RTS525A_LDO_VIO_CFG			0xFF75
#define REG_SDVIO_SR_MASK			0xC0
#define REG_SDVIO_SR_DF				0x40
#define REG_TUNEREF_VIO_MASK		0x30
#define REG_TUNEREF_VIO_1V2			0x20
#define REG_TUNE_VIO_MASK			0x07
#define REG_LDO_VIO_17V				0x03
#define REG_LDO_VIO_18V				0x04
#define REG_LDO_VIO_33V				0x07

#define RTS525A_LDO_DV12S_CFG		0xFF76
#define REG_TUNERFF12_MASK			0x18
#define REG_TUNERFF12_DF			0x10
#define REG_TUNED12_MASK			0x07
#define REG_TUNED12_DF		0x04

#define RTS525A_LDO_AV12S_CFG			0xFF77
#define REG_TUNE_AV12S_MASK			0x07
#define REG_TUNE_AV12S_DF			0x04

#define RTS525A_PME_FORCE_CTL			0xFF78
#define REG_EFUSE_BYPASS			0x08
#define REG_EFUSE_POR			0x04
#define REG_EFUSE_POWER_MASK			0x03
#define REG_EFUSE_POWERON			0x03
#define REG_EFUSE_POWEROFF			0x00

#define RTS525A_LDO_CFG2			0xFF71
#define RTS525A_LDO_D3318_MASK			0x07
#define RTS525A_LDO_D3318_18V			0x03
#define RTS525A_LDO_D3318_19V			0x04

#define RTS5250_PCIE_OFFSET_K_CFG		0xFF74
#define RTS5250_PCIE_OFFSET_K_MASK		0x0F
#define RTS5250_PCIE_OFFSET_K_DIS		0x80

#define RTS5250_PME_FORCE_CTL			0xFF76

#define RTS5250_LDO_CFG1			0xFF77

#define RTS5250_LDO_CFG2			0xFF78
#define RTS5250_LDO_D3318_MASK			0x07
#define RTS5250_LDO_D3318_33V			0x07
#define RTS5250_LDO_D3318_18V			0x02
#define RTS5250_LDO_D3318_19V			0x03

#define RTS5250_LDO_CFG3			0xFF79
#define REG_TUNE_DV12_MASK			0x07
#define REG_TUNE_DV12_1_15V			0x03

#define RTS524A_DELINK_CFG			0xFF7A
#define REG_DOWN_RELINK_INRUSH			0x08

#define RTS525A_CFG_MEM_PD			0xF0

#define RTS5250_AUTOLOAD_CFG1			0xFF7C
#define RTS5250_AUTOLOAD_CFG2			0xFF7D
#define RTS5250_AUTOLOAD_CFG3			0xFF7E
#define RTS5250_AUTOLOAD_CFG4			0xFF7F
#define RTS5250_ECO_PATCH				0xFE1C
#define RTS5250_PME_PATCH_MASK		0x2
#define RTS5250_PME_PATCH_EN			0x2

/* efuse control register*/
#define RTS525A_EFUSE_CTL			0xFC32
#define REG_EFUSE_ENABLE			0x80
#define REG_EFUSE_MODE			0x40

#define RTS525A_EFUSE_ADD			0xFC33
#define	REG_EFUSE_ADD_MASK			0x3F

#define RTS525A_EFUSE_DATA			0xFC35

struct rts5249_info {
	u8 gpio_input;
	int thermal_state;
#define THERMAL_STATE_TO_NORMAL			0
#define THERMAL_STATE_TO_BYPASS_CURRENT		1
#define THERMAL_STATE_TO_RANGE_A		2
#define THERMAL_STATE_TO_UHSI			3

	u64 thermal_time;
	int x;
};

int rts5249_calc_default_bier_val(struct card_reader *cr, u32 *val);
void rts5249_init_options(struct card_reader *cr);
void rts5249_init_hw_param(struct hw_param *hw_param);
void rts5250_init_hw_param(struct hw_param *hw_param);
void rts5249_init_sw_param(struct cr_option *option);
int rts5249_init(struct card_reader *cr);
void rts5249_auto_delink(struct card_reader *cr);
void rts5249_process_ocp(struct card_reader *cr);
void rts5250_process_ocp(struct card_reader *cr);
int rts5249_select_card(struct card_reader *cr, enum CARD_ID id);
int rts5249_detect_card(struct card_reader *cr, enum CARD_ID id);
void rts5249_before_power_down(struct card_reader *cr, int pm_stat);
int rts5249_do_resume(struct card_reader *cr);
void rts5249_update_pm(struct card_reader *cr);
int rts5249_poweroff_card(struct card_reader *cr, enum CARD_ID id);
int rts5249_poweron_card(struct card_reader *cr, enum CARD_ID id);
int rts5249_pre_handle_interrupt(struct card_reader *cr);
void rts5249_switch_to_sdio_ctrl(struct card_reader *cr);
int rts5249_get_ocpstat(struct card_reader *cr, u8 *val);
int rts5249_clear_ocpstat(struct card_reader *cr);
int rts5249_enable_ocp(struct card_reader *cr);
int rts5249_disable_ocp(struct card_reader *cr);
int rts5249_init_ocp(struct card_reader *cr);
void rts5249_enable_aspm(struct card_reader *cr);
void rts5249_disable_aspm(struct card_reader *cr);
void rts5249_enable_dma(struct card_reader *cr, u32 byte_cnt,
		u8 pack_size, enum dma_data_direction dir);
int rts5249_do_before_auto_delink(struct card_reader *cr);
void rts5250_deal_generic_extra_action(struct card_reader *cr);
/* for SD */

int rts5249_sd_power_off_card3v3(struct card_reader *cr);
void rts5249_sd_clear_sd_error(struct card_reader *cr);
int rts5249_sd_init_power(struct card_reader *cr);
int rts5249_sd_cleanup_work(struct card_reader *cr, struct card *c);
int rts5249_release_sd_card(struct card_reader *cr, struct card *c);
int rts5249_sd_set_sample_push_timing(struct card_reader *cr, struct card *c);
int rts5249_sd_current_over_limit400_handler(struct card_reader *cr);
int rts5250_sd_current_over_limit400_handler(struct card_reader *cr);
int rts5249_sd_change_bank_voltage(struct card_reader *cr, u8 voltage);
int rts5249_sd_pull_ctl_disable(struct card_reader *cr);
int rts5249_sd_pull_ctl_enable(struct card_reader *cr);

int rts5249_process_sd40_dormant_state(struct card_reader *cr, struct card *c,
		int dir, int dor_mode);
int rts5249_init_sd40_hw(struct card_reader *cr, struct card *c);
int rts5249_init_sd40_hw_m(struct card_reader *cr, struct card *c);
int rts5249_uninit_sd40_hw(struct card_reader *cr, struct card *c);

/* for MS */
int rts5249_ms_pull_ctl_enable(struct card_reader *cr);
int rts5249_ms_pull_ctl_disable(struct card_reader *cr);
int rts5249_sd_stop_sequential(struct card *card);
int rts5249_patch_special_sd(struct card_reader *cr, struct card *card);

int rts5250_poweron_card(struct card_reader *cr, enum CARD_ID id);
int rts5250_sd_change_bank_voltage(struct card_reader *cr, u8 voltage);
void rts5250_init_options(struct card_reader *cr);
void rts525a_init_options(struct card_reader *cr);
int rts5249_sd40_set_power_control_mode(struct card *c, u8 mode);
int rts5250_sd40_set_power_control_mode(struct card *c, u8 mode);
int rts5250_sd_init_power(struct card_reader *cr);
int rts5249_sd40_take_dev_init_process(struct card *card);
void rts5250_set_l1off_cfg_sub_D0(struct card_reader *cr, int active);
void rts5250_pm_full_on(struct card_reader *cr);
int rts5249_release_ms_card(struct card_reader *cr, struct card *card);
int rts5249_sd_prepare_reset(struct card_reader *cr, struct card *card);
int rts5249_sd40_set_n_fcu(struct card *c, u8 n_fcu);
void rts524a_init_options(struct card_reader *cr);
void rts524a_init_hw_param(struct hw_param *hw_param);
void rts524a_deal_generic_extra_action(struct card_reader *cr);
int rts524a_rd_phy16(struct card_reader *cr, u8 addr, u16 *val);
int rts524a_wr_phy16(struct card_reader *cr, u8 addr, u16 val);

void rts525a_init_hw_param(struct hw_param *hw_param);

int rts525a_enable_oobs_polling(struct card_reader *cr);
int rts525a_disable_oobs_polling(struct card_reader *cr);
int rts5250_patch_dma(struct card_reader *cr);

#endif
