#ifndef __SCSI_XFER_H__
#define __SCSI_XFER_H__
#include <asm/io.h>

unsigned int scsi_stor_access_xfer_buf(unsigned char *buffer,
	unsigned int buflen, struct scsi_cmnd *srb, unsigned int *index,
	unsigned int *offset, enum xfer_buf_dir dir);

void scsi_stor_set_xfer_buf(unsigned char *buffer,
       unsigned int buflen, struct scsi_cmnd *srb);

void scsi_stor_get_xfer_buf(unsigned char *buffer,
       unsigned int buflen, struct scsi_cmnd *srb);

unsigned int scsi_access_sglist(unsigned char *buffer,
				  unsigned int buflen, void *sglist,
				  void **sgptr, unsigned int *offset,
				  enum xfer_buf_dir dir);
unsigned int scsi_access_xfer_buf(unsigned char *buffer,
			    unsigned int buflen, struct scsi_cmnd *srb,
			    struct scatterlist **sgptr,
			    unsigned int *offset, enum xfer_buf_dir dir);
void scsi_get_xfer_buf(unsigned char *buffer,
			 unsigned int buflen, struct scsi_cmnd *srb);
void scsi_set_xfer_buf(unsigned char *buffer,
			 unsigned int buflen, struct scsi_cmnd *srb);

/**
 * scsi_check_xfer_len - check if len > scsi_bufflen(srb)
 * true:
 *	print warning and set len to scsi_bufflen(srb)
 */
#define scsi_check_xfer_len(srb, len)					\
	do {								\
		if ((len) > scsi_bufflen(srb)) {			\
			rts_trace(TRACE_SD, "scsi buffer too short[%d:%d]", \
				scsi_bufflen(srb), (len));		\
			(len) = scsi_bufflen(srb);			\
		}							\
	} while (0)

#endif
