#!/bin/bash

issue=$(cat /etc/issue | head -n1)

system=$(echo $issue | awk '{print $1}')
version=$(echo $issue | awk '{print $2}')
config="/etc/rc.modules"
if [[ "$system" = "Ubuntu" ]]
then
    echo "autoload module for ubuntu $version"
    if [[ -f "$config" ]]
    then
            modules=$(cat $config | grep rts-cr-host)
            if [ "$modules" == "" ]
            then
                echo "modprobe rts-cr-host" >> $config
            fi
    else
        echo "modprobe rts-cr-host" >> $config
    fi
    chmod +x $config
    exit 0
fi

system=$(echo $issue | awk '{print $1,$2,$3}')
version=$(echo $issue | grep -Eo '[[:digit:]]' | head -n1)
config=/etc/modules
if [[ "$system" = "Red Hat Enterprise" && "$version" == "6" ]]
then
    echo "autoload module for RHEL $version"
    echo "modprobe rts-cr-host" > /etc/sysconfig/modules/realtek-cr-scsi.modules
    chmod +x /etc/sysconfig/modules/realtek-cr-scsi.modules
    exit 0
fi
if [[ "$system" = "Red Hat Enterprise" && "$version" == "7" ]]
then
    echo "autoload module for RHEL $version"
    if [[ -f "$config" ]]
    then
            modules=$(cat $config | grep rts-cr-host)
            if [ "$modules" == "" ]
            then
                echo "rts-cr-host" >> $config
            fi
    else
        echo "rts-cr-host" >> $config
    fi
    chmod +x $config
    exit 0
fi

echo "Autoload realtek cardreader driver failed for $issue"


