#!/usr/bin/env python
# -*- coding:utf-8 -*-

import argparse
import os


this_dir = os.path.dirname(os.path.realpath(__file__))
root_dir = os.path.dirname(this_dir)


def shell_cmd(cmd):
    print cmd
    os.system(cmd)


def repo_name(ver):
    return "realtek-cr-scsi-{0}".format(ver)


def isgit():
    return os.path.exists(".git")


def goto_sroot():
    cwd = os.getcwd()
    if not os.path.exists("README.org"):
        os.chdir(root_dir)
    return cwd


def pack_git(ver, src=False):
    shell_cmd('git checkout-index -a -f --prefix="{0}/"'.format(repo_name(ver)))
    if (os.path.exists("README.pdf")):
        shell_cmd("cp README.pdf {0}".format(repo_name(ver)))
    shell_cmd("tar -czf {0}.tar.gz {0}".format(repo_name(ver)))
    if not src:
        shell_cmd("rm -rf {0}".format(repo_name(ver)))


def pack_cur(ver):
    cwd = os.getcwd()
    os.chdir("..")
    if not os.path.exists("{0}".format(repo_name(ver))):
        print("ERROR: please rename source name to {0}".format(repo_name(ver)))
    shell_cmd("tar -czf tmp.{0}.tar.gz {0}".format(repo_name(ver)))
    shell_cmd("mv tmp.{0}.tar.gz {0}/{0}.tar.gz".format(repo_name(ver)))
    os.chdir(cwd)


def parse_arguments():
    parser = argparse.ArgumentParser()
    parser.add_argument("--version", "-v", help="set version string")
    parser.add_argument("--src", "-s", action="store_true",
                        help="reserve source directory")
    return parser.parse_args()


if __name__ == "__main__":
    pa = parse_arguments()
    if not pa.version:
        pa.version = "1.4.3"

    cwd = goto_sroot()

    if isgit():
        pack_git(pa.version, pa.src)
    else:
        pack_cur(pa.version)

    os.chdir(cwd)
